MeanVar<-function(xx)
   {
   Beta<-0.2
    Mo <- median(xx)
    Vo <- 1
    DiffTol = 0.0001;
    DiffNorm = +10000;
    Iter = 0;
      while (DiffNorm > DiffTol)
      {
      Wt <- exp(-(Beta*(xx-Mo)^2)/(2*Vo))  
      Wt[which(Wt==0)]=0.000001
      while((sum(Wt<0.2)/length(Wt))>0.5)
      {Beta<-Beta-0.02;
      if(Beta<=0){Beta=.001}
      Wt <- exp(-(Beta*(xx-Mo)^2)/(2*Vo)) # Calculation of weights for each observation
      Wb<-sum(Wt<0.2)/length(Wt)
      }
      M.new <-  sum(Wt*xx)/sum(Wt) # Robust mean function
      V.new <- sum(Wt*(xx-Mo)^2)/sum(Wt) # Robust variance function
      DiffNorm <- sqrt(sum((M.new-Mo)^2))+sqrt(sum((V.new-Vo)^2))
      Mo = M.new
      Vo = V.new
      sd = sqrt(V.new)
      Iter = Iter + 1 
      } #END of while


###### Threshold Estimation based on sample obserbation
Sims<-Map(
   function(xx)
   {
     SimD<-rnorm(length(xx),Mo,sqrt(Vo))
     Wt.out<- exp(-(Beta*(SimD-Mo)^2)/(2*Vo))
   },
   1:1000                    # for(tt in 1:1000)
)
SimWt<-sapply(Sims, function(x) x[1])
###############################################################
out.Thr<-quantile(SimWt,10^-5)
  if (min(Wt)<out.Thr) # if minimum weight for an observation less than the estimated, 
                       # will take robust mean and variance otherwise classical mean and variance threshold 
     {M=Mo; V=Vo}
  else
   {M=mean(xx); V=var(xx)*(length(xx)-1)/length(xx)} # if no outlier
return(list(mu=M, Var=V))
}
################################################################################################
#===================================================
# ROBUST PARAMETER ESTIMATION
#===================================================
MeanVarWt.Beta<-function(xx)
   {
   Beta<-0.2
    Mo <- median(xx)
    Vo <- 1
    DiffTol = 0.0001;
    DiffNorm = +10000;
    Iter = 0;
      while (DiffNorm > DiffTol)
      {
      Wt <- exp(-(Beta*(xx-Mo)^2)/(2*Vo))  
      Wt[which(Wt==0)]=0.000001
      while((sum(Wt<0.2)/length(Wt))>0.5)
      {Beta<-Beta-0.02;
      if(Beta<=0){Beta=.001}
      Wt <- exp(-(Beta*(xx-Mo)^2)/(2*Vo)) # Calculation of weights for each observation
      Wb<-sum(Wt<0.2)/length(Wt)
      }
      M.new <-  sum(Wt*xx)/sum(Wt) # Robust mean function
      V.new <- sum(Wt*(xx-Mo)^2)/sum(Wt) # Robust variance function
      DiffNorm <- sqrt(sum((M.new-Mo)^2))+sqrt(sum((V.new-Vo)^2))
      Mo = M.new
      Vo = V.new
      sd = sqrt(V.new)
      Iter = Iter + 1 
      } #END of while


###### Threshold Estimation based on sample obserbation
Sims<-Map(
   function(xx)
   {
     SimD<-rnorm(length(xx),Mo,sqrt(Vo))
     Wt.out<- exp(-(Beta*(SimD-Mo)^2)/(2*Vo))
   },
   1:1000                    # for(tt in 1:1000)
)
SimWt<-sapply(Sims, function(x) x[1])
##================================================================
out.Thr<-quantile(SimWt,10^-5)
  if (min(Wt)<out.Thr) # if minimum weight for an observation less than the estimated, 
                       # will take robust mean and variance otherwise classical mean and variance threshold 
     {M=Mo; V=Vo}
  else
   {M=mean(xx); V=var(xx)*(length(xx)-1)/length(xx)} # if no outlier
out<-as.integer(which(Wt<out.Thr))
Wt.out<-Wt[out]
xx[out]<-M.new

return(list(xx.new=xx,mu=M, Var=V, sd=sqrt(V),out=out,Wt=Wt,
       Wt.out=Wt.out, SimWt=SimWt,out.Thr=out.Thr))
}
###################################################################################
###################################################################################
#===================================================
# ROBUST ANOVA
#===================================================
rAnova<-function(x)
{
Y.new<-Y
s<-x
##======   If any group length<3 then no variance
Table<-as.vector(table(x))
Names<-as.numeric(names(table(x)))
if(any(Table<2))
  {
    Y.new<-Y[x!=Names[Table<2]] 
    s<-x[x!=Names[Table<2]]
  }
##===========================================================
groups <- sort(unique(s))
ngroup <- length(groups)
Xber<-NULL;x1.bar<-NULL;var1<-NULL; n1pn2<-NULL
SimWt.g<-Thr.g<-SamWt.g<-NULL; OutS<-WtsOut<-NULL
  for(i in 1:ngroup)
  {
  b1MeanVar<-MeanVar(Y.new[s==groups[i]]) #Robust parameter estimation for each group samples
  x1.bar[i]<-b1MeanVar$mu               # Robust mean
  var1[i]<-b1MeanVar$Var                # Robust variance
  Xber[i]<-sum(s==groups[i])*x1.bar[i]
  }
xber<-sum(Xber)/length(s)
SSalpha<-NULL;SSE<-NULL; #var1<-NULL; #n1pn2<-NULL
  for(j in 1:ngroup)
  {
  SSalpha[j]<-sum(s==groups[j])*(x1.bar[j]-xber)^2
  SSE[j]<-sum(s==groups[j])*var1[j]
  }
SqAlpha<-sum(SSalpha)
SqE<-sum(SSE)
Fcal<-(SqAlpha/(ngroup-1))/(SqE/(length(s)-ngroup)) # Single F-Test
Fcal
pValueFq<-pf(Fcal, (ngroup-1), length(s)-ngroup, lower.tail = FALSE) # p-value calculation
return(P=pValueFq)
}
## If there thave any group length<3 then rAnova_old will shows problem
rAnova_old<-function(s)
{
groups <- sort(unique(s))
ngroup <- length(groups)
Xber<-NULL;x1.bar<-NULL;var1<-NULL; n1pn2<-NULL
SimWt.g<-Thr.g<-SamWt.g<-NULL; OutS<-WtsOut<-NULL
  for(i in 1:ngroup)
  {
  b1MeanVar<-MeanVar(Y.out[s==groups[i]]) #Robust parameter estimation for each group samples
  x1.bar[i]<-b1MeanVar$mu 		# Robust mean
  var1[i]<-b1MeanVar$Var 		# Robust variance
  Xber[i]<-sum(s==groups[i])*x1.bar[i]
  }
xber<-sum(Xber)/length(s)
SSalpha<-NULL;SSE<-NULL; #var1<-NULL; #n1pn2<-NULL
  for(j in 1:ngroup)
  {
  SSalpha[j]<-sum(s==groups[j])*(x1.bar[j]-xber)^2
  SSE[j]<-sum(s==groups[j])*var1[j]
  }
SqAlpha<-sum(SSalpha)
SqE<-sum(SSE)
Fcal<-(SqAlpha/(ngroup-1))/(SqE/(length(s)-ngroup)) # Single F-Test
Fcal
pValueFq<-pf(Fcal, (ngroup-1), length(s)-ngroup, lower.tail = FALSE) # p-value calculation
return(P=pValueFq)
}



