###################################################################################
###################################################################################
#===================================================
# ROBUST ANOVA
#===================================================
rAnova.Fn<-function(x)
{
#===================================================
if(anyNA(x))
  {
    index<-which(is.na(x))
    x<-x[-index]
    y<-pheno[-index]
  } else{
          x<-x
          y<-pheno
        }
#===================================================
Table0<-as.vector(table(x))
Names0<-as.numeric(names(table(x)))
if(sum(Table0)-max(Table0)>3)
  {
    Y.new<-y
    s<-x
##======   If any group length<3 then no variance
    Table<-as.vector(table(x))
    Names<-as.numeric(names(table(x)))
    if(any(Table<3))
      {
        Y.new<-y[x!=Names[Table<3]] 
        s<-x[x!=Names[Table<3]]
      }
##===========================================================
    groups <- sort(unique(s))
    ngroup <- length(groups)
    Xber<-NULL;x1.bar<-NULL;var1<-NULL; n1pn2<-NULL
    SimWt.g<-Thr.g<-SamWt.g<-NULL; OutS<-WtsOut<-NULL
      for(i in 1:ngroup)
      {
      b1MeanVar<-MeanVar(Y.new[s==groups[i]]) #Robust parameter estimation for each group samples
      x1.bar[i]<-b1MeanVar$mu               # Robust mean
      var1[i]<-b1MeanVar$Var                # Robust variance
      Xber[i]<-sum(s==groups[i])*x1.bar[i]
      }
    xber<-sum(Xber)/length(s)
    SSalpha<-NULL;SSE<-NULL; #var1<-NULL; #n1pn2<-NULL
      for(j in 1:ngroup)
      {
      SSalpha[j]<-sum(s==groups[j])*(x1.bar[j]-xber)^2
      SSE[j]<-sum(s==groups[j])*var1[j]
      }
    SqAlpha<-sum(SSalpha)
    SqE<-sum(SSE)
    Fcal<-(SqAlpha/(ngroup-1))/(SqE/(length(s)-ngroup)) # Single F-Test
    Fcal
    pValueFq<-pf(Fcal, (ngroup-1), length(s)-ngroup, lower.tail = FALSE) # p-value calculation
    return(P=pValueFq)
}
}